// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'DbpIndex.pas' rev: 3.00

#ifndef DbpIndexHPP
#define DbpIndexHPP
#include <Windows.hpp>
#include <TypInfo.hpp>
#include <Db.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Dbpindex
{
//-- type declarations -------------------------------------------------------
enum TFieldCompareOption { fcoEqual, fcoMore, fcoLess };

enum TDPSeekOption { dsoFirstEQ, dsoLastEQ, dsoAfterEQ, dsoAfter, dsoBeforeEQ, dsoBefore };

enum TDPGotoOption { dgoFirst, dgoLast, dgoNone };

struct TIndexFieldDef;
typedef TIndexFieldDef *PIndexFieldDef;

struct TIndexFieldDef
{
	System::Variant Value;
	Db::TField* Field;
	bool CaseInsensitive;
	bool Descending;
} ;

struct TIndexRecord
{
	System::AnsiString FieldNames;
	System::AnsiString CaseInsFields;
	System::AnsiString DescFields;
	Db::TIndexOptions Options;
} ;

typedef int __fastcall (__closure *TCompareFunction)(const System::AnsiString S1, const System::AnsiString 
	S2, const bool CaseInsensitive);

class DELPHICLASS TDPIndexDefs;
class PASCALIMPLEMENTATION TDPIndexDefs : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Db::TDataSet* FDataSet;
	Classes::TList* FIndexFields;
	TDPSeekOption FSeekOption;
	int FFoundRecNo;
	int FIndexHighBound;
	int FLocaleID;
	TCompareFunction FCompareObject;
	bool __fastcall FindFieldName(const System::AnsiString FieldName, const System::AnsiString FieldNames
		, const bool DefaultValue);
	bool __fastcall SimpleMethod(int &i, int &j);
	TFieldCompareOption __fastcall CheckIndexFields(void);
	bool __fastcall IndexFind(const TDPGotoOption Default);
	TIndexFieldDef __fastcall GetItem(int Index);
	int __fastcall GetCount(void);
	void __fastcall SetLocaleID(int Value);
	int __fastcall DPAnsiCompare(const System::AnsiString S1, const System::AnsiString S2, const bool CaseInsensitive
		);
	int __fastcall DPCompare(const System::AnsiString S1, const System::AnsiString S2, const bool CaseInsensitive
		);
	
protected:
	virtual Db::TDataSet* __fastcall GetDataSet(void) = 0;
	virtual void __fastcall DoAfterDataSetChanged(void);
	virtual void __fastcall DoAfterIndexChanged(void);
	virtual TIndexRecord __fastcall GetIndexRecord(void) = 0;
	TFieldCompareOption __fastcall CheckIndexField(const System::Variant &FieldValue, const System::Variant 
		&SearchValue, const TIndexFieldDef &IndexField);
	bool __fastcall Seek(const System::Variant &KeyValues, const TDPSeekOption SeekOption, const TDPGotoOption 
		Default);
	__property Db::TDataSet* DataSet = {read=FDataSet};
	__property int LocaleID = {read=FLocaleID, write=SetLocaleID, default=1024};
	
public:
	__fastcall TDPIndexDefs(void);
	__fastcall virtual ~TDPIndexDefs(void);
	virtual bool __fastcall IsUpdateIndex(void);
	virtual bool __fastcall IsUpdateDataSet(void);
	void __fastcall UpdateDataSet(void);
	void __fastcall UpdateIndex(void);
	__property int Count = {read=GetCount, nodefault};
	__property TIndexFieldDef Items[int Index] = {read=GetItem};
};

class DELPHICLASS TBaseDataSetIndex;
class PASCALIMPLEMENTATION TBaseDataSetIndex : public Dbpindex::TDPIndexDefs 
{
	typedef Dbpindex::TDPIndexDefs inherited;
	
private:
	bool FDefaultIndex;
	TIndexRecord FIndexRecord;
	bool __fastcall IsOptionsStored(void);
	bool __fastcall IsCaseInsFieldsStored(void);
	bool __fastcall IsDescFieldsStored(void);
	bool __fastcall IsFieldNamesStored(void);
	void __fastcall SetDefaultIndex(bool Value);
	void __fastcall SetFieldNames(System::AnsiString Value);
	void __fastcall SetOptions(Db::TIndexOptions Value);
	void __fastcall SetCaseInsFields(System::AnsiString Value);
	void __fastcall SetDescFields(System::AnsiString Value);
	Db::TIndexOptions __fastcall GetOptions(void);
	System::AnsiString __fastcall GetCaseInsFields(void);
	System::AnsiString __fastcall GetDescFields(void);
	System::AnsiString __fastcall GetFieldNames(void);
	void __fastcall UpdateIndexDef(void);
	
protected:
	virtual TIndexRecord __fastcall GetIndexRecord(void);
	virtual Db::TIndexOptions __fastcall InternalGetOptions(void);
	virtual System::AnsiString __fastcall InternalGetCaseInsFields(void);
	virtual System::AnsiString __fastcall InternalGetDescFields(void);
	virtual System::AnsiString __fastcall InternalGetFieldNames(void);
	
public:
	__fastcall TBaseDataSetIndex(void);
	
__published:
	__property bool DefaultIndex = {read=FDefaultIndex, write=SetDefaultIndex, default=1};
	__property Db::TIndexOptions Options = {read=GetOptions, write=SetOptions, stored=IsOptionsStored, 
		nodefault};
	__property System::AnsiString CaseInsFields = {read=GetCaseInsFields, write=SetCaseInsFields, stored=
		IsCaseInsFieldsStored};
	__property System::AnsiString DescFields = {read=GetDescFields, write=SetDescFields, stored=IsDescFieldsStored
		};
	__property System::AnsiString FieldNames = {read=GetFieldNames, write=SetFieldNames, stored=IsFieldNamesStored
		};
public:
	/* TDPIndexDefs.Destroy */ __fastcall virtual ~TBaseDataSetIndex(void) { }
	
};

class DELPHICLASS TQueryIndex;
class PASCALIMPLEMENTATION TQueryIndex : public Dbpindex::TBaseDataSetIndex 
{
	typedef Dbpindex::TBaseDataSetIndex inherited;
	
private:
	System::AnsiString FFieldNames;
	System::AnsiString FDescFields;
	bool FDefaultIndexDef;
	Classes::TStrings* FSQL;
	void __fastcall UpdateTypeInfo(void);
	void __fastcall SetSQLProperty(void);
	
protected:
	virtual Db::TIndexOptions __fastcall InternalGetOptions(void);
	virtual System::AnsiString __fastcall InternalGetCaseInsFields(void);
	virtual System::AnsiString __fastcall InternalGetDescFields(void);
	virtual System::AnsiString __fastcall InternalGetFieldNames(void);
	virtual void __fastcall DoAfterDataSetChanged(void);
	virtual TIndexRecord __fastcall GetIndexRecord(void);
	virtual Classes::TStrings* __fastcall GetSQLStrings(void);
	
public:
	virtual bool __fastcall IsUpdateIndex(void);
public:
	/* TBaseDataSetIndex.Create */ __fastcall TQueryIndex(void) : Dbpindex::TBaseDataSetIndex() { }
	
public:
	/* TDPIndexDefs.Destroy */ __fastcall virtual ~TQueryIndex(void) { }
	
};

class DELPHICLASS TDataSetIndex;
class PASCALIMPLEMENTATION TDataSetIndex : public Dbpindex::TQueryIndex 
{
	typedef Dbpindex::TQueryIndex inherited;
	
private:
	Db::TIndexDef* FIndexDef;
	bool FDefaultIndexDef;
	Db::TIndexDefs* FIndexDefs;
	Typinfo::TPropInfo *FIndexNamePropInfo;
	Typinfo::TPropInfo *FIndexFieldNamesPropInfo;
	System::AnsiString FIndexName;
	System::AnsiString FIndexFieldNames;
	Db::TIndexOptions __fastcall GetDefaultOptions(void);
	System::AnsiString __fastcall GetDefaultCaseInsFields(void);
	System::AnsiString __fastcall GetDefaultDescFields(void);
	Db::TIndexDef* __fastcall GetDefaultIndexDef(void);
	System::AnsiString __fastcall GetDefaultIndexFieldNames(void);
	HIDESBASE void __fastcall UpdateTypeInfo(void);
	Db::TIndexDef* __fastcall GetIndexDef(void);
	bool __fastcall IsTableIndex(void);
	
protected:
	virtual void __fastcall DoAfterDataSetChanged(void);
	virtual void __fastcall DoAfterIndexChanged(void);
	virtual TIndexRecord __fastcall GetIndexRecord(void);
	virtual Db::TIndexOptions __fastcall InternalGetOptions(void);
	virtual System::AnsiString __fastcall InternalGetCaseInsFields(void);
	virtual System::AnsiString __fastcall InternalGetDescFields(void);
	virtual System::AnsiString __fastcall InternalGetFieldNames(void);
	virtual System::AnsiString __fastcall GetIndexFieldNames(void);
	virtual System::AnsiString __fastcall GetIndexName(void);
	virtual Db::TIndexDefs* __fastcall GetIndexDefs(void);
	
public:
	virtual bool __fastcall IsUpdateIndex(void);
	virtual bool __fastcall IsUpdateDataSet(void);
public:
	/* TBaseDataSetIndex.Create */ __fastcall TDataSetIndex(void) : Dbpindex::TQueryIndex() { }
	
public:
	/* TDPIndexDefs.Destroy */ __fastcall virtual ~TDataSetIndex(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define DEFAULT_LOCALEID (Word)(1024)
#define DEFAULT_LOCALEID_ASCII (Shortint)(-1)
extern PACKAGE bool __fastcall CaseSensitiveDependent(const Db::TFieldType DataType);

}	/* namespace Dbpindex */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Dbpindex;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// DbpIndex
